#pragma once

#include "Object.h"
#include "Ball.h"

class Powerup : public Object
{
public:
	enum Type { MASS, ACCELERATION, MAX_SPEED };

	Powerup(char* filename, Vector offset, Type _type);
	~Powerup();

	virtual void collided(Ball& ball);
	virtual void advanceTime(float timestep);

private:
	// the amounts by which powerups affect the ball
	static const float MASS_INCREASE;
	static const float ACCELERATION_INCREASE;
	static const float MAX_SPEED_INCREASE;

	// stuff relating to the animation of the powerup exploding when you pick it up
	static const float EXPLOSION_DURATION;
	static const float EXPLOSION_SPEED;
	float timeSinceExplosion;
	bool exploding;
	Vector *explosionVelocities;

	Type type;
};
