#pragma once

#include "shape.h"
#include <GL/glut.h>

class Sphere :
	public Shape
{
public:
	Sphere(Vector cen, float rad, Color c);
	~Sphere(void);
	virtual void draw() const;
	virtual void drawRotated(const float* rotMatrix) const;
	Vector getCenter() const { return center; }
	void setCenter(Vector newCenter) { center = newCenter; }
	float getRadius() const { return radius; }

private:
	Vector center;
	float radius;
	GLUquadricObj* theSphere;
	unsigned char*		bitmapData;			// the texture data
	int hTexture;							// the texture handle
	int hBall;								// the display list handle
	static int numSpheres;
};
