// camera.h - definition of camera class
#pragma once

#include "includes.h"

class Camera
{
public: 
	Camera();
	~Camera();

	// Set the focal point
	void lookAt(Vector p);
	// Set the position of the camera relative to the focal point in spherical coordinates (degrees)
	void setPosition(float newR, float newTheta, float newPhi);
	// Set the position of the camera relative to its current position
	void setRelativePosition(float dR, float dTheta, float dPhi);
	// Do the OpenGL tranform calls to set up the camera viewpoint
	void doTransform() const; 
	// theta accessor
	float getTheta() const { return theta; }
	// r accessor
	float getR() const { return r; }
//	float getDesiredR() const { return desiredR; }
	// advance time when doing smooth zooming for the smash bros. camera
	void advanceTime(float amount);
	// set the desired R (zoom level) for the smash bros. camera
	void setMaxOffScreen(float newOffScreen) { maxOffScreen = newOffScreen; }
	// set the desired focal point for the smash bros. camera
	void setDesiredFocalPoint(Vector point) { desiredFocalPoint = point; };
private:
	float maxOffScreen;
	float r, theta, phi;
	Vector focalPoint, desiredFocalPoint;
};