//SEE CHANGE LOG UNDER RESOURCE FILES
#define GLUT_DISABLE_ATEXIT_HACK
#include <iostream>
#include <GL/glut.h>
#include "camera.h" 
#include <float.h>
// our includes
#include "World.h"
#include "Triangle.h"
#include "Ball.h"

using namespace std;


bool moving = false;

// function prototypes
void display(void);
void reshape(int width, int height);
void init(void); 

int main(int argc, char **argv)
{
	if(argc == 1)
	{
		MessageBox(NULL, "Please execute marbles.exe to play the game.", "Information", MB_OK);
		exit(0);
	}
  // enable floating point exceptions
//  _controlfp( _EM_INEXACT | _EM_INVALID , _MCW_EM ); 
  // set up window
  glutInitWindowSize(400, 400);
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
  glutCreateWindow("Untitled #2 g0lf");

  // register callback functions
  glutDisplayFunc(display);
  glutReshapeFunc(reshape);

  // initalize opengl parameters
  init();

  if(argc > 2)
  {
	  if(strcmp(argv[2], "-c") == 0)
		World::instance()->setMode(ARENA);
	  else if(strcmp(argv[2], "-s") == 0)
		World::instance()->setMode(SURVIVAL);
	  else if(strcmp(argv[2], "-r") == 0)
		World::instance()->setMode(RACE);
  }


  // Load in file if specified on command line, otherwise load default file "input.txt"
  if(argc > 1)
	  World::instance()->loadFile(argv[1]);
  else
	  World::instance()->loadFile("arena.txt");

  if(argc > 3)
	World::instance()->setKeys(argv[3]);


  // loop until something happens
  glutMainLoop();
  return 0;           
}
void init()
{
  // initialize viewing system
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(45.0, 1.0, 0.1, 500.0); 
  glMatrixMode(GL_MODELVIEW);

  // initialize background color to black
  glClearColor(0.0,0.0,0.0,0.0);
 
  // enable depth buffering
  glEnable(GL_DEPTH_TEST);
}



void reshape(int width, int height)
{
  glViewport(0,0,width,height);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(45.0, ((float)width)/((float)height), 0.1, 500.0); 
  glMatrixMode(GL_MODELVIEW);
}

void display()
{
	// Draw everything in the world
	World::instance()->draw();
}
